import React, { Component, Fragment } from 'react';
import { withRouter } from "react-router-dom";
import { Breadcrumb, Button } from 'antd';
import { get } from "../../service/Global";
import './ItemNav.scss'

@withRouter
export default class ItemNav extends Component {
  constructor(props) {
    super(props)
    this.state = {
      a: '',
    }
  }
  componentWillMount() {
    this.setState({
      a: get('readonly')
    })
  }
  render() {
    return (
      <Fragment>
        <div className="breadcrumb-nav">
          {
            (() => {
              if (this.props.itemNav.list) {
                return (
                  <div className="nav-group">
                    <Breadcrumb>
                      {
                        this.props.itemNav.list.map((item, i) => {
                          return (
                            <Breadcrumb.Item key={i.toString()}>{item.anchor}</Breadcrumb.Item>
                          )
                        })
                      }
                    </Breadcrumb>
                  </div>
                )
              }
            })()
          }
          {
            (() => {
              if (this.props.itemNav.extends) {
                return (
                  <div className="btn-group">
                    {
                      this.props.itemNav.extends.map((item, i) => {
                        if (item.url) {
                          return (
                            <Button key={i.toString()} type={item.type} onClick={() => { this.props.history.push(item.url) }} disabled={this.state.a == 1 ? true : false}>
                              {
                                (() => {
                                  if (item.icon) {
                                    return <i className="iconfont" dangerouslySetInnerHTML={{ __html: item.icon }}></i>
                                  }
                                })()
                              }
                              {item.label}
                            </Button>
                          )
                        } else if (item.render) {
                          return item.render()
                        }
                      })
                    }
                  </div>
                )
              }
            })()
          }
        </div>
      </Fragment>
    )
  }
}
