import React, { Component } from 'react';
import { Layout } from 'antd';
import {Action, Store} from 'marine';
import { withRouter,hashHistory } from 'react-router-dom';
import Headers from './components/Headers';
import Aside from './components/Aside';
import MainRoutes from './MainRoutes';
import { ConfigProvider } from 'antd';
import zh_CN from 'antd/lib/locale-provider/zh_CN';
import moment from 'moment';
import 'moment/locale/zh-cn';
import {set} from "../../service/Global";
import {hasIt} from "../../service/utils";
moment.locale('zh-cn');
const {Content} = Layout;
@withRouter
export default class BasicLayout extends Component {
  constructor(props) {
    super(props);
    this.state = {
      projectId:''
    };
  }

  projectIdChange = (id)=>{
    Action.global.getProjectId({project_id:id});
    this.setState({
      projectId:id
    });
    if(!hasIt('/app/list',window.location.href)){
      // this.props.history.push('/app/list')
    }
  };

  componentDidMount() {
    Store.on('global.projectIdSave',StoreDate =>{
      set('project_id', StoreDate.data.project_id);
    })
  }


  render() {
    return (
        <Layout style={{height:'100%'}}>
          <Aside />
          <Layout>
            <Headers history={this.props.history}/>
            {
              <Content style={{overFlow:'hidden'}}>
                <ConfigProvider  locale={zh_CN}>
                    <MainRoutes/>
                </ConfigProvider>
              </Content>
            }
          </Layout>
        </Layout>
    );
  }
}
