import React, { Component } from 'react';
import { Redirect, Switch, Route } from 'react-router-dom';
import { asideMenuConfig } from '../../menuConfig';
import routerData from '../../routerConfig';
import NotFound from '../../components/NotFound'
import {clear, get} from "../../service/Global";
import HttpClient from "../../service/HttpClient";
import Api from '../../service/Api'
let old = [{
  name: '监控预警',
  path: '/monitor',
  icon: '&#xe654;',
  authority: 'user',
  children: [{
      name: '提现监控管理',
      path: '/monitor/manage',
      authority: 'user',
    },
    {
      name: '通知管理人',
      path: '/monitor/manger',
      authority: 'user',
    },
    
    {
      name: '报警通知',
      path: '/monitor/inform',
      authority: 'user',
      
    },
    
  ]
},

{
  name: '玩家查询',
  path: '/query',
  icon: '&#xe657;',
  authority: 'user',
  children:[
    {
      name: '玩家货币查询',
      path: '/query/player',
      authority: 'user',
     
    },
  ]
},
{
  name: '白名单',
  path: '/white',
  icon: '&#xe657;',
  authority: 'user',
  children:[
    {
      name: '白名单管理',
      path: '/white/mange',
      authority: 'user',
     
    },
    
  ]
},
{
  name: '系统设置',
  path: '/set',
  icon: '&#xe657;',
  authority: 'user',
  children:[
    {
      name: '用户管理',
      path: '/set/user',
      authority: 'user',
     
    },
  ]
}
];
class MainRoutes extends Component {
  static displayName = 'MainRoutes';

  constructor(props) {
    super(props);
    this.state = {
      asideMenuConfig: []
    }
  }
  componentWillMount() {
    this.setState({
      asideMenuConfig:old
    })
    // let scanType = get('scanCode');
    // if (scanType == 0) {
    //   this.setState({
    //     asideMenuConfig:old
    //   })
    // } else {
    //   this.headerMenuConfigs();
     
    // }
  }
  headerMenuConfigs = () => {
    HttpClient.get(Api.menu).then(data => {
      this.setState({
        asideMenuConfig: data
      })
     
    })
  }
  /**
   * 根据菜单取得重定向地址.
   */
  getRedirectData = () => {
    const asideMenuConfig=this.state.asideMenuConfig
    const redirectData = [];
    const getRedirect = (item) => {
      if (item && item.children) {
        if (item.children[0] && item.children[0].path) {
          redirectData.push({
            from: `${item.path}`,
            to: `${item.children[0].path}`,
          });
          item.children.forEach((children) => {
            getRedirect(children);
          });
        }
      }
    };
    asideMenuConfig.forEach(getRedirect);
    return redirectData;
  };

  /**
   * 渲染路由组件
   */
  renderNormalRoute = (item, index) => {
    let token = get('token');
    if(item.authority === 'admin'){
      if (token) {
        if(get('overdue_data') < Date.now()){
          clear();
          window.location.href='/#/login';
          return
        }
      } else {
        window.location.href='/#/login';
        return
      }
    }
    return item.component ? (
      <Route
        key={index}
        path={item.path}
        component={item.component}
        exact={item.exact}
      />
    ) : null;
  };
  render() {
    const redirectData = this.getRedirectData();
    return (
      <Switch>
        {/* 渲染路由表 */}
        {routerData.map(this.renderNormalRoute)}
        {/* 路由重定向，嵌套路由默认重定向到当前菜单的第一个路由 */}
        {redirectData.map((item, index) => {
          return <Redirect key={index} exact from={item.from} to={item.to} />;
        })}

        <Redirect exact from="/" to="/" />
        {/* 未匹配到的路由重定向到 <Guide> 组件，实际情况应该重定向到 404 */}
        <Route component={NotFound} />
      </Switch>
    );
  }
}

export default MainRoutes;
