import React, { Component } from 'react';
import { Link } from 'react-router-dom';
import { withRouter } from 'react-router-dom';
import { Menu, Icon, Button, Layout } from 'antd';
import { get,set } from "../../../../service/Global";
import HttpClient from "../../../../service/HttpClient";
import Api from '../../../../service/Api'
import Logo from '../Logo/Logo'
import { asideMenuConfig } from '../../../../menuConfig';

const SubMenu = Menu.SubMenu;
const { Sider } = Layout;
let old = [{
  name: '监控预警',
  path: '/monitor',
  icon: '&#xe654;',
  authority: 'user',
  children: [{
      name: '提现监控管理',
      path: '/monitor/manage',
      authority: 'user',
    },
    {
      name: '通知管理人',
      path: '/monitor/manger',
      authority: 'user',
    },
    
    {
      name: '报警通知',
      path: '/monitor/inform',
      authority: 'user',
      
    },
    
  ]
},

{
  name: '玩家查询',
  path: '/query',
  icon: '&#xe657;',
  authority: 'user',
  children:[
    {
      name: '玩家货币查询',
      path: '/query/player',
      authority: 'user',
     
    },
  ]
},
{
  name: '白名单',
  path: '/white',
  icon: '&#xe657;',
  authority: 'user',
  children:[
    {
      name: '白名单管理',
      path: '/white/mange',
      authority: 'user',
     
    },
    
  ]
},
{
  name: '系统设置',
  path: '/set',
  icon: '&#xe657;',
  authority: 'user',
  children:[
    {
      name: '用户管理',
      path: '/set/user',
      authority: 'user',
     
    },
  ]
}
];
@withRouter
export default class Aside extends Component {
  constructor(props) {
    super(props);
    this.state = {
      asideMenuConfig: []
    }
  }
  componentWillMount() {
    this.setState({
      asideMenuConfig:old
    })
    // let scanType = get('scanCode');
    // if (scanType == 0) {
     
    // } else {
    //   this.headerMenuConfigs();
    // }
    
  }
  headerMenuConfigs = () => {
    HttpClient.get(Api.menu).then(data => {
      this.setState({
        asideMenuConfig: data
      })
      
    })
  }
  /**
   * 获取默认展开菜单项
   */
  getDefaultOpenKeys = () => {
    const { location = {} } = this.props;
    const { pathname } = location;
    const asideMenuConfig=this.state.asideMenuConfig
    const menus = this.getNavMenuItems(asideMenuConfig);
    let openKeys = [];
    if (Array.isArray(menus)) {
      asideMenuConfig.forEach((item, index) => {
        if (pathname.startsWith(item.path)) {
          openKeys = [`${index}`];
        }
      });
    }

    return openKeys;
  };


  toggleCollapsed = () => {
    this.setState({
      collapsed: !this.state.collapsed,
    });
  };

  /**
   * 获取菜单项数据
   */
  getNavMenuItems = (menusData) => {
    if (!menusData) {
      return [];
    }
    return menusData.filter(item => item.name && !item.hideInMenu).map((item, index) => {
      const role = get('role');
      if (item.authority === 'user') {
        return this.getSubMenuOrItem(item, index);
      } else {
        if (role === 'admin' || role === 'configurer') {
          return this.getSubMenuOrItem(item, index);
        }
      }
    });
  };
  handleClick=(item)=>{
    // if(!item){return}
    set('readonly',item)
  }
  /**
   * 二级导航
   */
  getSubMenuOrItem = (item, index) => {
    if (item.children && item.children.some(child => child.name)) {
      const childrenItems = this.getNavMenuItems(item.children);
      if (childrenItems && childrenItems.length > 0) {
        return (
          <SubMenu key={item.path + index} title={<span>
            {
              (() => {
                if (item.icon) {
                  return <i className="iconfont mr-12" dangerouslySetInnerHTML={{ __html: item.icon }}></i>
                } else {
                  return null
                }
              })()
            }
            {item.name}
          </span>}>
            {childrenItems}
          </SubMenu>
        );
      }
      return null;
    }
    return (
      <Menu.Item key={'#' + item.path}>
        <Link to={item.path} onClick={()=>this.handleClick(item.readonly)}>
          {
            (() => {
              if (item.icon) {
                return <i className="iconfont mr-12" dangerouslySetInnerHTML={{ __html: item.icon }}></i>
              } else {
                return null
              }
            })()
          }
          {item.name}
        </Link>
      </Menu.Item>
    );
  };

  render() {
    const asideMenuConfig=this.state.asideMenuConfig
    return (
      <Sider style={{ height: '100%', maxWidth: '160px', backgroundColor: '#FFF', boxShadow: '0 1px 10px rgba(200,200,200,.5)', zIndex: '999' }}>
        <Logo />
        <Menu selectedKeys={[window.location.hash]} defaultOpenKeys={['sub0']} mode="inline">
          {this.getNavMenuItems(asideMenuConfig)}
        </Menu>
      </Sider>
    )
  }
}
