import React,{Fragment} from 'react';
import moment from 'moment';
import { withRouter } from "react-router-dom";
import ItemNav from "../../components/ItemNav";
import ItemTableQuery from "../../components/ItemTableQuery";
import ItemTable from "../../components/ItemTable";
import HttpClient from "../../service/HttpClient";
import Api from "../../service/Api";
import { set, get } from "../../service/Global";
import {Tag, Button, Empty, Modal, Table, Input,Form, Select,Popconfirm,message} from 'antd';
import {dateFormat, parseParams} from "../../service/utils";
import {Store} from "marine";
import './index.scss'
const { TextArea } = Input;
@withRouter
 class MonitorMange extends React.Component{
  constructor(props){
    super(props);
    this.state={
      visible: false,
      platData:[],
      channelData:[],
      dataSource:{},
      currencyData:[],
      list:{},
      selectedRowKeys:[],
    }
  }
  form;
  defaultParams = {
    page:1,
    pageSize:10
  };
  itemNav = {
    list: [{ anchor: "提现监控管理" }],
  };
  columns = [
    { title: "平台", dataIndex: "platform", key: "platform"},
    { title: "渠道", dataIndex: "channel", key: "channel" },
    { title: "货币", dataIndex: "type", key: "type" },
    { title: "单次最高提现", dataIndex: "oneWithdrawal", key: "oneWithdrawal", },
    { title: "单日最高提现", dataIndex: "dayWithdrawal", key: "dayWithdrawal"},
    { title: "每日单用户最高提现", dataIndex: "userDayWithdrawal", key: "userDayWithdrawal",},
    { title: "状态", dataIndex: "statusName", key: "statusName",},
    { title: "操作", dataIndex: "operate", key: "operate",render:(text,record)=>{
      return <div>
        <Button type='default' className='ml-10 edit' onClick={()=> this.showBatchModal(record)}>修改</Button>
         <Popconfirm
        title="你确定删除吗?"
        onConfirm={()=>{this.handleDelete(record.id)}}
        //onCancel={this.cancel}
        okText="Yes"
        cancelText="No"
        >
          <Button type='link ml-20 delete-red' >删除</Button>
        </Popconfirm>
      </div> 
    }}
  ];
  handleDelete=(id)=>{
    return HttpClient.post(Api.warnDelete,{id:id}).then(data => {
        if(data){
            message.success('删除成功！');
            this.getList(this.defaultParams)
        }
        
      })
  }
  getList(params){
    return HttpClient.post(Api.warnList,{...params,}).then(data => {
      this.setState({
        dataSource: data,
      })
    })
  }

  getPlatList(){
    return HttpClient.post(Api.platformList).then(data => {
      let tmp=[]
      for(var i in data){
        if(i!=0){
          let obj= {id:i,name:data[i]}
          tmp.push(obj)
        }
        
      }
      this.setState({
        platData:tmp
      })
    })
  }
  channelList=()=>{
    return HttpClient.post(Api.channelList).then(data => {
      let tmp=[]
      for(var i in data){
        if(i!=0){
          let obj= {id:i,name:data[i]}
          tmp.push(obj)
        }
      }
      this.setState({
        channelData:tmp
      })
    })
  }
  currencyList=()=>{
    return HttpClient.post(Api.currencyList).then(data => {
      let tmp=[]
      for(var i in data){
        if(i!=0){
          let obj= {id:i,name:data[i]}
          tmp.push(obj)
        }
      }
      this.setState({
        currencyData:tmp
      })
    })
  }
  pager = (page) => {
    this.defaultParams = Object.assign({},this.defaultParams,{page:page});
    this.getList(this.defaultParams);
  };
  getTableQuery=(params)=>{
   
    this.defaultParams = Object.assign(this.defaultParams,{...params});
    this.getList(this.defaultParams);
  };
  resetParams = ()=>{
    this.defaultParams = {};
    this.setState({
      tableData:{}
    })
  };

  handleCancel = () => {
    this.setState({ visible: false });
  };
  handleOk=()=>{
    const id=this.state.list.id;
    this.props.form.validateFields((err, values) => {
      if (!err) {
        console.log('Received values of form: ', values);
        if(id){
          HttpClient.post(Api.warnEdit,{...values,id:id}).then(data => {
           
            this.setState({ visible: false });
            this.getList(this.defaultParams)
           })
        }else{
          HttpClient.post(Api.warnAdd,{...values}).then(data => {
           
            this.setState({ visible: false });
            this.getList(this.defaultParams)
           })
        }
       
      }
    });
    
  }
 
 
  showBatchModal = (list) => {
     if(list){
      this.setState({visible: true,list});
    }else{

      this.setState({visible: true,list:{}});
    }
  };
  handleStart=(status)=>{
    const that=this;
    const {selectedRowKeys}=this.state;
    if(selectedRowKeys.length==0){
      message.info('请至少选择一个！');
      return;
    }
    
    return HttpClient.post(Api.warnStatusAll,{status,ids:selectedRowKeys.join('#')}).then(data => {
     if(data){
       message.success('操作成功');
       this.getList(this.defaultParams);
       that.setState({
         selectedRowKeys:null,
       })
     }
    })
  }

  componentDidMount() {
    this.getPlatList();
    this.channelList()
    this.currencyList()
    this.getList(this.defaultParams)
  }

  render() {
    const {platData,channelData,currencyData,list,selectedRowKeys}=this.state;
    const itemTableQuery= [
         
      {
        label:'所属平台',
        type: "select",
        key: "platform",
        mode:"multiple",
        data: platData,
        placeholder: "全部",
      },
      {
        label:'所属渠道',
        type:'select',
        key:'channel',
        mode:"multiple",
        placeholder: "全部",
        data:channelData,
        //defaultValue:"0"
      },
     
      {
        type:'select',
        key:'status',
        label:'状态',
        defaultValue:"0",
        data:[
          {name:'全部',id:"0"},
          {name:'启用',id:1},
          {name:'停用',id:2},
        ],
      },
     
      {
        type: "submit",
        extend: false,
        render: <Fragment>
           <Popconfirm
        title="你确定启用吗?"
        onConfirm={()=> this.handleStart(1)}
        //onCancel={this.cancel}
        okText="Yes"
        cancelText="No"
        >
          <Button type='default' className='ml-10 start' >启用</Button>
        </Popconfirm>
        <Popconfirm
        title="你确定暂停吗?"
        onConfirm={()=> this.handleStart(2)}
        //onCancel={this.cancel}
        okText="Yes"
        cancelText="No"
        >
            <Button type='default' className='ml-10 stop' >暂停</Button>
           </Popconfirm>
          </Fragment>,
      },
    ];
    const { getFieldDecorator } = this.props.form;
    const formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 8 },
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
      },
    };
    const rowSelection = {
      selectedRowKeys,
      onChange: (selectedRowKeys, selectedRows) => {
        console.log(`selectedRowKeys: ${selectedRowKeys}`);
        this.setState({selectedRowKeys})
      },
      // onSelect: (record, selected, selectedRows) => {
      //   //console.log(record, selected, selectedRows);
      // },
      // onSelectAll: (selected, selectedRows, changeRows) => {
      //  // console.log(selected, selectedRows, changeRows);
      // },
    };
    return(
      <Fragment>
            <ItemNav itemNav={this.itemNav} />
            <section className='content-base'>
          <div className='mb-20 formwrapper'>
            <div className='formBg'><ItemTableQuery getTableQuery={this.getTableQuery} resetParams={this.resetParams} itemTableQuery={itemTableQuery} /></div>
            <Button type='primary' className='ml-20' onClick={()=> this.showBatchModal()}>设置监控提现</Button>
          </div>
         
          <ItemTable columns={this.columns} dataSource={this.state.dataSource} pager={this.pager} rowSelection={rowSelection}/>
        </section>
        <Modal  title="设置提现监控"
          visible={this.state.visible}
          onOk={this.handleOk}
          onCancel={this.handleCancel}>
            <Form {...formItemLayout} >
                <Form.Item label="所属平台">
              {getFieldDecorator('platform', {
                initialValue:list.platformId?list.platformId.toString():'',
                rules: [
                  // {
                  //   required: true,
                  //   message: '请选择',
                  // },
                ],
                })(
                  <Select placeholder='全部' disabled={list.platformId?true:false}>
                    {
                      platData&&platData.map((item,i)=>{
                        return <Select.Option value={item.id} key={i}>{item.name}</Select.Option>
                      })
                    }
                    
                  </Select>
                )}
              </Form.Item>
              <Form.Item label="所属渠道" placeholder='请选择'>
              {getFieldDecorator('channel', {
                 initialValue:list.channelId?list.channelId.toString():'',
                rules: [
                 
                  {
                    required: true,
                    message: '请选择',
                  },
                 
                ],
                })(
                  <Select disabled={list.channelId?true:false} placeholder='全部'>
                    {
                      channelData&&channelData.map((item,i)=>{
                        return <Select.Option value={item.id} key={i}>{item.name}</Select.Option>
                      })
                    }
                    
                  </Select>
                )}
              </Form.Item>
              <Form.Item label="货币">
              {getFieldDecorator('type', {
                initialValue:list.typeId?list.typeId.toString():'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                  <Select disabled={list.typeId?true:false}>
                    {
                      currencyData&&currencyData.map((item,i)=>{
                        return <Option value={item.id} key={i}>{item.name}</Option>
                      })
                    }
                  </Select>
                )}
              </Form.Item>
             
              <Form.Item label="单日单次最高提现值">
              {getFieldDecorator('oneWithdrawal', {
                initialValue:list?list.oneWithdrawal:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                <Input/>
                )}
              </Form.Item>
              <Form.Item label="单日最高提现值">
              {getFieldDecorator('dayWithdrawal', {
                initialValue:list?list.dayWithdrawal:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                <Input/>
                )}
              </Form.Item>
              <Form.Item label="单日单用户最高提现值">
              {getFieldDecorator('userDayWithdrawal', {
                initialValue:list?list.userDayWithdrawal:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                <Input/>
                )}
              </Form.Item>
            </Form>
        </Modal>
      </Fragment>
    )
  }
}
export default Form.create()(MonitorMange)