import React,{Fragment} from 'react';
import moment from 'moment';
import { withRouter } from "react-router-dom";
import ItemNav from "../../components/ItemNav";
import ItemTableQuery from "../../components/ItemTableQuery";
import ItemTable from "../../components/ItemTable";
import HttpClient from "../../service/HttpClient";
import Api from "../../service/Api";
import { set, get } from "../../service/Global";
import {Tag, Button, Empty, Modal, Table, Input,Form, Select,Popconfirm,message} from 'antd';
import {dateFormat, parseParams} from "../../service/utils";
import {Store} from "marine";
const { TextArea } = Input;
@withRouter
 class WhiteMange extends React.Component{
  constructor(props){
    super(props);
    this.state={
      visible: false,
      list:{},
      startText:'启用',
      stopText:'暂停',
      disableds:false,
      disabledt:false,
      dataSource:{},
    }
  }
  form;
  defaultParams = {
    page:1,
    pageSize:10
  };
  itemNav = {
    list: [{ anchor: "白名单管理" }],
  };
  columns = [
    { title: "ID", dataIndex: "id", key: "id",width: 100},
    { title: "账号", dataIndex: "name", key: "name", },
    { title: "状态", dataIndex: "status", key: "status",render:text=>{
      if(text==1){
        return '开启'
      }else{
        return '关闭'
      }
    }},
    { title: "创建人", dataIndex: "optionUser", key: "optionUser",},
    { title: "创建时间", dataIndex: "addTime", key: "addTime",},
    { title: "操作", dataIndex: "operate", key: "operate",render:(text,record)=>{
      return <div>
          <Button type='link start-color' onClick={()=> this.handleStart(record.id,1)} disabled={record.status==1?true:false}>{record.status==1?'已启用':'启用'}</Button>
          <Button type='link  delete-red' onClick={()=> this.handleStart(record.id,2)} disabled={record.status==2?true:false}>{record.status==2?'已暂停':'暂停'}</Button>
        {/* <Button type='link' onClick={()=> this.showBatchModal(record)}>修改</Button> */}
        <Popconfirm
                title="你确定删除吗?"
                onConfirm={()=> this.handleDelete(record)}
                onCancel={this.cancel}
                okText="Yes"
                cancelText="No"
            >
               <Button type='link delete-red ml-20'>删除</Button>
            </Popconfirm>
        
      </div>
    }},
  ];
  handleStart(id,status){
    return HttpClient.post(Api.setWhiteStatus,{id:id,status:status}).then(data => {
      if(status==1){
        message.success('当前账号白名单功能已启用!')
      }else{
        message.warn('当前账号白名单功能已暂停!')
      }
      this.getList(this.defaultParams)
    })
  }
 
  handleDelete=(record)=>{
    return HttpClient.post(Api.deleteUserList,{id:record.id}).then(data => {
        message.success('删除成功！')
       this.getList(this.defaultParams)
      })
  }
  getList(params){
    return HttpClient.post(Api.getWhiteList,{...params}).then(data => {
      console.log(data)
      this.setState({
        dataSource: data,
      })
    })
  }

  pager = (page) => {
    this.defaultParams = Object.assign({},this.defaultParams,{page:page});
    this.getList(this.defaultParams);
  };
  getTableQuery=(params)=>{
    this.defaultParams = Object.assign(this.defaultParams,{...params});
    this.getList(this.defaultParams);
  };


  handleCancel = () => {
    this.setState({ visible: false });
  };
  handleOk=()=>{
   
    this.props.form.validateFields((err, values) => {
    if (!err) {
      console.log('Received values of form: ', values);
      HttpClient.post(Api.addWhite,{...values}).then(data => {
         
         this.setState({ visible: false });
         this.getList(this.defaultParams)
        })
    }
  });
  }

 
  showBatchModal = () => {
    this.setState({visible: true});
  };
 

  componentDidMount() {
    this.getList(this.defaultParams)
  }

  render() {
    const itemTableQuery= [
      {
        label:'状态',
        type:'select',
        key:'status',
       // mode:'multiple',
        placeholder:'全部',
       // defaultValue:-1,
        data:[
          // {name:'全部',id:-1},
          {name:'启用',id:1},
          {name:'禁用',id:2},
          ],
          
      },
      {
        type:'input',
        key:'name',
       placeholder:'请输入姓名'
      },
     
      {
        type: "submit",
        extend: false,
        render: <Fragment>
           
          </Fragment>,
      },
    ];
    const { getFieldDecorator } = this.props.form;
    const formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 8 },
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
      },
    };
   const {list}=this.state;
    return(
      <Fragment>
            <ItemNav itemNav={this.itemNav} />
            <section className='content-base'>
          <div className='mb-20 formwrapper'>
           <div className='formBg'><ItemTableQuery getTableQuery={this.getTableQuery}  itemTableQuery={itemTableQuery} /></div>
           <Button type='primary' className='ml-20' onClick={()=> this.showBatchModal()}>添加白名单</Button>
          </div>
         
          <ItemTable columns={this.columns} dataSource={this.state.dataSource} pager={this.pager} />
        </section>
        <Modal  title="添加白名单"
          visible={this.state.visible}
          onOk={this.handleOk}
          onCancel={this.handleCancel}>
            <Form {...formItemLayout} >
              <Form.Item label="姓名">
              {getFieldDecorator('name', 
              
              {
                initialValue:list?list.name:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                //  {
                //     max:5,
                //     message:'最大长度5位'
                //  }
                ],
                })(
                <Input/>
                )}
              </Form.Item>
              <Form.Item label="账号">
              {getFieldDecorator('uid', {
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                  // {
                  //   len:11,
                  //   message:'字段长度11位'
                  // }
                ],
                })(
                <Input/>
                )}
              </Form.Item>
             
            </Form>
        </Modal>
      </Fragment>
    )
  }
}
export default Form.create()(WhiteMange)